%define Werror_cflags	%{nil}
%define _ssp_cflags	%{nil}
%define	cflags	%{optflags}

Summary:	Multi-call binary combining many common Unix tools into one executable
Name:		busybox
Version:	1.24.2
Release:	2
Epoch:		1
License:	GPLv2+
Group:		Shells
URL:		http://www.busybox.net/
Source0:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2
Source1:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2.sign
Source2:	busybox-1.20.2-config
Source3:	busybox-1.18.4-minimal-config
Patch1:		busybox-i.15.2-no-march_i386.patch
Patch12:	busybox-1.2.2-ls.patch
# the default behaviour of busybox' pidof implementation is same as for
# 'pidof -x' from the standard implementation, so let's just make it
# ignore -x in stead of returning error
Patch17:	busybox-1.20.2-pidof-x-argument.patch
# These patches will be likely merged into the next upstream release
Patch100:	busybox-1.24.2-CVE-2016-2147.patch
Patch101:	busybox-1.24.2-CVE-2016-2148.patch
Patch102:	busybox-1.24.2-ash-recursive-heredocs.patch
Patch103:       busybox-1.24.2-CVE-2016-6301.patch
BuildRequires:	glibc-static-devel
BuildRequires:	tirpc-static-devel

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable. It provides minimalist replacements for most
of the utilities you usually find in GNU coreutils, shellutils, etc.
The utilities in BusyBox generally have fewer options than their
full-featured GNU cousins; however, the options that are included provide
the expected functionality and behave very much like their GNU counterparts.
BusyBox provides a fairly complete POSIX environment for any small or
embedded system.

BusyBox has been written with size-optimization and limited resources in
mind. It is also extremely modular so you can easily include or exclude
commands (or features) at compile time. This makes it easy to customize
your embedded systems. To create a working system, just add /dev, /etc,
and a kernel.

%package	static
Group:		Shells
Summary:	Static linked busybox

%description	static
This package contains a static linked busybox.

%prep
%setup -q
%patch1 -p1
%patch12 -p1
%patch17 -p1
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1

%build
mkdir -p full.static
pushd full.static
cp %{SOURCE2} .config
mv .config .config1 && \
    grep -v \
        -e ^CONFIG_FEATURE_HAVE_RPC \
        -e ^CONFIG_FEATURE_MOUNT_NFS \
        -e ^CONFIG_FEATURE_INETD_RPC \
        .config1 >.config && \
    echo "# CONFIG_FEATURE_HAVE_RPC is not set" >>.config && \
    echo "# CONFIG_FEATURE_MOUNT_NFS is not set" >>.config && \
    echo "# CONFIG_FEATURE_INETD_RPC is not set" >>.config && \
yes "" | %make oldconfig V=1 KBUILD_SRC=.. -f ../Makefile
%make CC=%{__cc} LDFLAGS="%{ldflags}" LDLIBS="-ltirpc -lm" V=1 CONFIG_STATIC=y CONFIG_EXTRA_CFLAGS="%{cflags}" KBUILD_SRC=.. -f ../Makefile
popd

mkdir -p full
pushd full
cp %{SOURCE2} .config
yes "" | %make oldconfig V=1 KBUILD_SRC=.. -f ../Makefile
%make CC=%{__cc} LDFLAGS="%{ldflags}" LDLIBS="-ltirpc -lm" V=1 CONFIG_STATIC=n CONFIG_EXTRA_CFLAGS="%{cflags}" KBUILD_SRC=.. -f ../Makefile
popd

%check
# FIXME
%if 0
%make CC=%{__cc} V=1 check
%endif

%install
install -m755 full/busybox_unstripped -D %{buildroot}%{_bindir}/busybox
install -m755 full.static/busybox_unstripped -D %{buildroot}/bin/busybox.static

%files
%doc AUTHORS README TODO
%{_bindir}/busybox

%files static
%doc AUTHORS README TODO
/bin/busybox.static

%changelog

* Wed Aug 31 2016 Denis Silakov <dsilakov@gmail.com> 1:1.24.2-2
- (081c141) Fix CVE-2016-6301


